def GITLAB_ACTION= ""
pipeline {
  agent any
 

    parameters {
        booleanParam(defaultValue: false, description: 'Compile back ', name: 'COMPILE_BACK')
        booleanParam(defaultValue: false, description: 'Compile Front  ', name: 'COMPILE_FRONT')
        booleanParam(defaultValue: false, description: 'Compile Front Project ', name: 'DEPLOY_FRONT_PROD')
        booleanParam(defaultValue: false, description: 'Compile Front Project ', name: 'DEPLOY_BACK')
        booleanParam(defaultValue: false, description: 'Compile Front Project ', name: 'DEPLOY_FRONT_DEV')
        booleanParam(defaultValue: false, description: 'Compile Back Project ', name: 'DEPLOY_BACK_DEV')
        booleanParam(defaultValue: false, description: 'Test back ', name: 'Test_BACK')
   

    }

    tools {
        nodejs "Node"
        maven "Maven"
    }
    environment {
        MAVEN_HOME = '/Users/hajarbelhoucine/Downloads/apache-maven-3.6.3'
        NODE_HOME = '/usr/local/'


    }


    triggers {
        pollSCM '* * * * *'
    }
    stages {
        stage("Info"){
            steps{
                script{
                    GITLAB_ACTION = env.gitlabActionType

                }
            }
        }
        stage('Build Back') {
            when {
                expression { params.COMPILE_BACK || GITLAB_ACTION == 'PUSH'}  
            }
            steps {
                sh """ 
                cd ServiceProduct
                ${MAVEN_HOME}/bin/mvn compile 
                """

            }
        }

        stage('Test Back') {
            when {
                expression { params.Test_BACK || GITLAB_ACTION == 'PUSH'}  
            }
            steps {
                  sh """ 
                cd ServiceProduct
                ${MAVEN_HOME}/bin/mvn test
                """

            }
        }
       

        stage('Deploy Back ') {
            when {
                expression { params.DEPLOY_BACK || GITLAB_ACTION == 'PUSH'}  
            }
          
            
            steps {
                sh """
           
              docker run  -d -it  -p 8000:8000 -p 8087:8087 -p 8001:8001 produit-service:latest  

                """
            }
        }
          
        stage('Build Front') {
             when {
                expression {  params.COMPILE_FRONT || GITLAB_ACTION == 'PUSH'}  
            }
            steps {
                
                sh "env"
                sh """
                cd client-plateforme
                npm install
                npm run build
                """
                
         
               
            }
        }
         
    
       

         stage('Deploy Front DEV ') {
            when {
                expression {   params.DEPLOY_FRONT_DEV || GITLAB_ACTION == 'PUSH' }  
            }
            steps {
                sh "env"
                sh """
                cd client-plateforme
                npm start
                """
            }
        }

         stage('Deploy Front Production') {
            when {
                expression { params.DEPLOY_FRONT_PROD || GITLAB_ACTION == 'PUSH' }  
            }
             steps {
                echo"hello"
            }
         
        }
        
    }
}
